// Checker created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;



int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	vector<vector<char>> field(n, vector<char>(n));

	for (int i = 0; i < n; ++i) {
		string s = inf.readToken();
		for (int j = 0; j < n; ++j) {
			field[i][j] = s[j];
		}
	}

	auto check_outp = [&](auto& stream) {
		string outcome = lowerCase(stream.readLine());
		stream.ensuref(outcome == "yes" || outcome == "no", "outcome should be equal to \"yes\" or \"no\"");

		if (outcome == "no") {
			return 0;
		}

		vector<vector<char>> cur(n, vector<char>(n));

		for (int i = 0; i < n; ++i) {
			string s = stream.readLine();
			stream.ensuref(szof(s) == n, "length of line should be %d", n);
			for (char c : s) {
				stream.ensuref(c == '|' || c == '-' || c == 'O' || c == '.', "bad symbol '%c'", c);
			}
			for (int j = 0; j < n; ++j) {
				char tmp = s[j];
				if (tmp == '|' || tmp == '-') {
					tmp = '+';
				}
				stream.ensuref(tmp == field[i][j], "symbol '%c' in cell (%d, %d) doesn't match original symbol '%c'", s[j], i + 1, j + 1, field[i][j]);
				cur[i][j] = s[j];
			}
		}

		vector<vector<bool>> used(n, vector<bool>(n));

		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (field[i][j] == 'O') {
					for (int k = i - 1; k >= 0 && cur[k][j] == '|'; --k) {
						used[k][j] = true;
					}
					for (int k = i + 1; k < n && cur[k][j] == '|'; ++k) {
						used[k][j] = true;
					}

					for (int k = j - 1; k >= 0 && cur[i][k] == '-'; --k) {
						used[i][k] = true;
					}
					for (int k = j + 1; k < n && cur[i][k] == '-'; ++k) {
						used[i][k] = true;
					}
				}
			}
		}

		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (field[i][j] == '+' && !used[i][j]) {
					stream.quitf(_wa, "cell (%d, %d) isn't reachable from any center", i + 1, j + 1);
				}
			}
		}

		return 1;
	};

	int jans = check_outp(ans);
	int pans = check_outp(ouf);

	if (jans && !pans) {
		quitf(_wa, "participant didn't find solution, but it exists");
	}

	if (!jans && pans) {
		quitf(_fail, "jury didn't find solution, but it exists");
	}

	if (!jans && !pans) {
		quitf(_ok, "solution doesn't exist");
	}

	quitf(_ok, "solution found");

	return 0;
}